#!/usr/bin/python
# -*- coding: iso-8859-1 -*-

from math import sqrt
from re import sub
from string import upper,find

def mittelwert(seq):
   # Mittelwert eines Arrays zurckgeben
   m=0.0
   for i in seq:
      m = m+i
   return m/len(seq)

def abweichung(seq):
   # Standardabweichung eines Arrays zurckgeben
   mw = mittelwert(seq)
   n = len(seq)
   sum = 0
   for v in seq:
      sum = sum + (v-mw)**2
   return sqrt ( sum / (n-1) )
   
def median(seq):
   # Median-Wert eines Arrays zurckgeben
   seq2 = []
   for v in seq: seq2.append(v)
   seq2.sort()
   return seq2 [ len(seq2)/2 ]

def medsplit(seq,med):
   s1 = []  # Werte <= med
   s2 = []  # Werte > med
   for v in seq:
      if v <= med:
         s1.append(v)
      else:
         s2.append(v)
   return (s1,s2)

def fixvals(seq1,seq2):
   # Aufrumen: Werte, die nher am Mittelwert der anderen Folge sind,
   # rberschieben
   m1 = mittelwert(seq1)
   m2 = mittelwert(seq2)
   for v in seq2:
      if abs(v-m2) > abs (v-m1):
         seq2.remove(v)
         seq1.append(v)
   for v in seq1:
      if abs(v-m1) > abs (v-m2):
         seq1.remove(v)
         seq2.append(v)
   return (seq1,seq2)

### cc_bits_to_ascii
### Diese Funktion wandelt einen 01-String wieder in ASCII zurueck.
### als zweites Argument wird die Anzahl der am Anfang zu ignorierenden
### Bits ausgegeben.
def cc_bits_to_ascii (s,index):
   result = ""
   pos = 0
   v = 0
   if index != 0: result=result+"?"
   for c in s[index:]:
      if c == "1": v = v+2**(5-pos)
      pos = pos+1
      if pos == 6:
         pos = 0
         result = result + chr (v+32)   # Zeichen anh-bngen-A
         v = 0
   return result

### cc_ascii_to_bits
### Diese Funktion wandelt eine ASCII-Nachricht in eine Folge
### aus Nullen und Einsen. Es werden nur Zeichen zwischen ASCII 32 und 95
### kodiert (= 64 Zeichen = 6 Bit). Startsequenz: 32, 95
# modifizierte Version: ohne Header und Footer
def cc_ascii_to_bits (s):
   result = ""  # ohne (!) Start-Sequenz
   s = upper(s)
   for c in s:
      if c < chr(32) or c > chr (95): c = chr(32)
      v = ord(c)-32        # i jetzt zwischen 0 und 63
      for i in [5,4,3,2,1,0]:
         if v & (2**i):
            result=result+"1"
         else:
            result=result+"0"
   return result


def bitfehler (s1,s2):
   length = min (len(s1),len(s2))
   s1 = s1[:length]  # abschneiden
   s2 = s2[:length]
   errcount = []
   for i in range(0,length):
      if s1[i] != s2[i]: errcount.append(i)
   return errcount


infile=open("data.in","r")
#outfile=open("data.out","w")

s=infile.read()
infile.close()

vals=[]
for v in s.split():
   vals.append(float(v))

med = median(vals)
mw = mittelwert(vals)
(vals1,vals2) = medsplit(vals,med)

print "Gesamtwerte"
print "Median:     %1.10f" % med
print "Mittelwert: %1.10f" % mw
print "Abweichung: %1.10f" % abweichung(vals)

print "Unterer Block"
print "Minimum:    %1.10f" % min(vals1)
print "Maximum:    %1.10f" % max(vals1)
print "Mittelwert: %1.10f" % mittelwert(vals1)
print "Abweichung: %1.10f" % abweichung(vals1)

print "Oberer Block"
print "Minimum:    %1.10f" % min(vals2)
print "Maximum:    %1.10f" % max(vals2)
print "Mittelwert: %1.10f" % mittelwert(vals2)
print "Abweichung: %1.10f" % abweichung(vals2)

(vals1,vals2) = fixvals(vals1,vals2)

print "AUFRAEUMEN"
print "Unterer Block"
print "Minimum:    %1.10f" % min(vals1)
print "Maximum:    %1.10f" % max(vals1)
print "Mittelwert: %1.10f" % mittelwert(vals1)
print "Abweichung: %1.10f" % abweichung(vals1)

print "Oberer Block"
print "Minimum:    %1.10f" % min(vals2)
print "Maximum:    %1.10f" % max(vals2)
print "Mittelwert: %1.10f" % mittelwert(vals2)
print "Abweichung: %1.10f" % abweichung(vals2)

# trenner = (min(vals2)-max(vals1))/2
trenner = max(vals1)+0.0001
# trenner = 0.1

msgbin = ""
for v in vals:
   if v < trenner:
      msgbin = msgbin+"0"
   else:
      msgbin = msgbin+"1"

print "Nachricht: ",msgbin

# index=find(msgbin,"11111000000")
# msgbin=msgbin[index+11:]
msgbin=msgbin[12:]
print "Nachricht: ",msgbin

#  fhrenden Mll lschen

print "Text:      ", cc_bits_to_ascii(msgbin,0)

originaltext = """0@ .,NN'.:9I1]D4<S';]&S>ASUL,K?L&,KO5'\S0<TOY"W5SGR6]D*;P+9&I@&A02 =UA*VH>!]R%M.GP8Q)P@..ZO-SMU:$HT/Z7/!E$ *Y%.3HM^2#**5QS"*21(N _"""

print "Original:  ", originaltext

bf = bitfehler (msgbin,cc_ascii_to_bits(originaltext))
print "Bitfehler: ", len(bf),": ",bf
print "Laenge:    ", len(cc_ascii_to_bits(originaltext))
print "Fehler %:  ", (len(bf)+0.0)/(len(cc_ascii_to_bits(originaltext))+0.0)*100





#p1 = cc_ascii_to_bits(originaltext)
#p2 = msgbin
#
#print "1: ",p1
#print "2: ",p2

#outfile.write(str(i)+" "+v+"\n")
#outfile.close()
